	includeh	quickdraw.def	*Defintion files we use
	includeh	palettes.def
	includeh	windows.def
	includeh	memory.def
	includeh	resources.def
	includeh	quickdrawtext.def
	includeh	OSUtils.def
	includeh	general_usage.def
**************************************************************
*Clut_fade - utilities.s
*(C)Lightsoft 96/97
**************************************************************
**create a big window in case screen is not 640*480 to mask desktop so now update delays
*in Finder - you could even quit the finder.
open_window:
	mflr	r29
	clr.l	r3
	lwz	r4,bounds_rect(rtoc)	*big rectangle
	lwz	r5,wtitle(rtoc)
	li	r6,1
	li	r7,8
	li	r8,-1
	li	r9,0
	li	r10,0
	Xcall	NewCWindow

	stw	r3,bg_window_ptr(`bss)

**Get the 640*480 window we're drawing into
	li	r3,128	*windows id is 128
	li	r4,0	*clear param2 - storage
	li	r5,-1	*behind
	Xcall	GetNewCWindow	*Note NewCWindow, else we'd have problems with the colors.		
	stw	r3,demo_window_ptr(`bss)
**get the viewable rectangle (top,left,bottom,right)
	la	r3,16(r3)	*windoptr+16=viewrect
	la	r4,viewrect_1(`bss)
	lfd	f0,(r3)		*64 bit move into f0
	stfd	f0,(r4)		*64 bit store into viewrect_1
**And copy to our second rectangle as well
	la	r4,viewrect_2(`bss)
	stfd	f0,(r4)		*into viewrect_2	

**set the port to our window
	lwz	r3,demo_window_ptr(`bss)
	Xcall	SetPort		
	mtlr	r29
	blr

****FIll_lines
fill_lines:
	mflr	r29
**reset the x and y's
	lwz	r3,bounds_rect(rtoc)	*top,left,bott,right
	lhz	r20,2(r3)	*left of window
	lhz	r21,6(r3)	*right of window
	lhz	r22,4(r3)	*bottom
	li	r16,0
**Draw line and alter the components of the colour
line_loop_2:
**get next colour
	lwz	r15,current_clut_h(`bss)
	lwz	r15,(r15)
	inc	r16
	cmpwi	r16,255
	bne	colour_ok
	li	r16,zero
colour_ok:
	mr	r3,r16
	lwz	r4,new_colour(`bss)
	Xcall	Index2Color	*Should use our own code here to speed this up
	lwz	r3,new_colour(`bss)
	Xcall	RGBForeColor	*Set new forground colour		
	bl	draw_line	*draw this line
	subic.	r22,r22,1	*up 1 line
	bne	line_loop_2	*and if not top of window (line=0) draw next line in new colour.
	li	r3,100
	li	r4,250
	Xcall	MoveTo
	li	r3,0
	lwz	r4,new_colour(`bss)
	Xcall	Index2Color
	lwz	r3,new_colour(`bss)
	Xcall	RGBForeColor	*Set new forground colour		

	li	r3,36
	Xcall	TextSize
	li	r3,3
	Xcall	TextMode
	lwz	r3,test_text(rtoc)
	Xcall	DrawString
	mtlr	r29
	blr
****FIll_v_lines
**Same as above, but draws lines vertically
fill_v_lines:
	mflr	r29
**reset the x and y's
	lwz	r3,bounds_rect(rtoc)	*top,left,bott,right
	lhz	r20,(r3)	*top of window
	lhz	r21,4(r3)	*bottom of window
	lhz	r22,6(r3)	*right
	li	r16,0
**Draw line and alter the components of the colour
line_loop_v:
**get next colour
	lwz	r15,current_clut_h(`bss)
	lwz	r15,(r15)
	inc	r16
	cmpwi	r16,255
	bne	colour_okv
	li	r16,zero
	
colour_okv:
	mr	r3,r16
	lwz	r4,new_colour(`bss)
	Xcall	Index2Color
	lwz	r3,new_colour(`bss)
	Xcall	RGBForeColor	*Set new forground colour		
	bl	draw_v_line	*draw this line
	subic.	r22,r22,1	*up 1 line
	bne	line_loop_v	*and if not top of window (line=0) draw next line in new colour.
	li	r3,3
	li	r4,200
	Xcall	MoveTo
	li	r3,0
	lwz	r4,new_colour(`bss)
	Xcall	Index2Color
	lwz	r3,new_colour(`bss)
	Xcall	RGBForeColor	*Set new forground colour		
	li	r3,1
	Xcall	TextFont

	li	r3,48
	Xcall	TextSize
	li	r3,3
	Xcall	TextMode
	lwz	r3,wicked_text(rtoc)
	Xcall	DrawString


	mtlr	r29
	blr

print_text:
	mflr	r28
	li	r3,200
	li	r4,300
	Xcall	MoveTo
	li	r3,0
	lwz	r4,new_colour(`bss)
	Xcall	Index2Color
	lwz	r3,new_colour(`bss)
	Xcall	RGBForeColor	*Set new forground colour		
	li	r3,4
	Xcall	TextFont
	li	r3,24
	Xcall	TextSize
	li	r3,3
	Xcall	TextMode
	lwz	r3,lib_text(rtoc)
	Xcall	DrawString
	mtlr	r28
	blr

print_text1:
	mflr	r28
	li	r3,200
	li	r4,240
	Xcall	MoveTo
	li	r3,0
	lwz	r4,new_colour(`bss)
	Xcall	Index2Color
	lwz	r3,new_colour(`bss)
	Xcall	RGBForeColor	*Set new foreground colour	 	 
	li	r3,4
	Xcall	TextFont
	li	r3,24
	Xcall	TextSize
	li	r3,3
	Xcall	TextMode
	lwz	r3,done_text(rtoc)
	Xcall	DrawString
	mtlr	r28
	blr

show_copyright:
	mflr	r28
	li	r3,200
	li	r4,280
	Xcall	MoveTo
	lwz	r3,white(rtoc)
	Xcall	RGBForeColor	*Set new foreground colour	 	 
	li	r3,4
	Xcall	TextFont
	li	r3,12
	Xcall	TextSize
	li	r3,1
	Xcall	TextMode
	lwz	r3,c_text_1(rtoc)
	Xcall	DrawString
	li	r3,200
	li	r4,320
	Xcall	MoveTo
	lwz	r3,c_text_2(rtoc)
	Xcall	DrawString

	li	r3,200
	li	r4,360
	Xcall	MoveTo
	lwz	r3,c_text_3(rtoc)
	Xcall	DrawString

	mtlr	r28
	blr

************************************************************
*************************************************
**Draws a horizontal line in the forground colour.
**Needs start x in r20, end x in r21 and y in r22
draw_line:
	mflr	r27
	mr	r3,r20
	mr	r4,r22
	Xcall	MoveTo
	mr	r3,r21
	mr	r4,r22
	Xcall	LineTo
	mtlr	r27
	blr

**Draws a vertical line in the forground colour.
**Needs start y in r20, end y in r21 and x in r22
draw_v_line:
	mflr	r27
	mr	r3,r22
	mr	r4,r20
	Xcall	MoveTo
	mr	r3,r22
	mr	r4,r21
	Xcall	LineTo
	mtlr	r27
	blr
*****************
**Drawing subroutine follow
draw_circles:
	mflr	r29		*save return addr.
**First reduce our viewrect_2 down to a small size
	la	r20,viewrect_1(`bss)	*copy this rect
	la	r22,viewrect_2(`bss)	*to this rect whilst making it bigger
	lhz	r21,(r20)
	subic.	r21,r21,130
	sth	r21,(r22)	*top-100
	
	lhz	r21,2(r20)
	subic.	r21,r21,100
	sth	r21,2(r22)	*left-100

	lhz	r21,4(r20)
	addic.	r21,r21,130
	sth	r21,4(r22)	*bottom+100

	lhz	r21,6(r20)
	addic.	r21,r21,100
	sth	r21,6(r22)	*right+100

	li	r26,200		*loop count
	li	r16,zero	*color counter
**Now drow r26 circles, each slightly smaller than the last	 
circles:
	la	r3,viewrect_2(`bss)	*top,left,bott,right	
	Xcall	PaintOval			*simple?

	la	r20,viewrect_2(`bss)	
	lhz	r21,(r20)
	addic.	r21,r21,5
	sth	r21,(r20)	*top+2
	
	lhz	r21,2(r20)
	addic.	r21,r21,5
	sth	r21,2(r20)	*left+2

	lhz	r21,4(r20)
	subic.	r21,r21,5
	sth	r21,4(r20)	*bottom-2

	lhz	r21,6(r20)
	subic.	r21,r21,5
	sth	r21,6(r20)	*right-2

	inc	r16
	cmpwi	r16,255		*check colour
	bne	colour_okc
	li	r16,zero
	
colour_okc:
	mr	r3,r16
	lwz	r4,new_colour(`bss)	*rgb goes here
	Xcall	Index2Color		*it would be much faster to do this manually from the clut
	lwz	r3,new_colour(`bss)
	Xcall	RGBForeColor	*Set new forground colour		

	subic.	r26,r26,1
	bne	circles
	mtlr	r29
	blr
	
bounds_rect:	dc.h	0,0,1200,1440	*top,left,bott,right
bounds_rect640:	dc.h	0,0,480,640
black:	dc.h	0x0,0x0,0x0
white:	dc.h	0xffff,0xffff,0xffff
wtitle:	cstring	""
test_text:	pstring	"Test Lightsoft 1996/7"
wicked_text:	pstring "What's going on here then?"
lib_text:	pstring	"Vid Lib Clut Test"
done_text:	pstring	"This had to be done :-)"

c_text_1:	pstring	"      Copyright  Lightsoft 1996/7"
c_text_2:	pstring	"          CLUT Test project"
c_text_3:	pstring	""

	global	open_window,fill_lines,fill_v_lines,print_text,draw_circles,print_text1
	global	show_copyright